/** Rill v0.0.484 https://www.npmjs.com/package/rill License: MIT*/
var Request, expect, parseURL;

parseURL = require("parse-url");

expect = require("./util/expect");

Request = (function() {
  function Request(req, basePath) {
    var defaults, key, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, val;
    if (basePath == null) {
      basePath = "";
    }
    if (!(this instanceof Request)) {
      return new Request(req, basePath);
    }
    expect(req != null, "Could not create Request with an empty object.");
    expect(req.url != null, "Could not create a Request without a URL.");
    this.originalReq = req;
    this.headers = (ref = req.headers) != null ? ref : {};
    this.method = (ref1 = req.method) != null ? ref1 : "GET";
    {
      this.ip = "127.0.0.1";
      defaults = window.location;
    }
    ref7 = parseURL(req.url, {
      basePath: basePath,
      defaults: defaults
    });
    for (key in ref7) {
      val = ref7[key];
      this[key] = val;
    }
  }


  /*
  	 * Trigger another request that will redirect the browser and send a location change on the server.
  	 * If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
  	#
  	 * @param {String} url
  	 * @param {String} alt
   */

  Request.prototype.redirect = function(url, alt) {
    if (url == null) {
      url = "back";
    }
    if (alt == null) {
      alt = "/";
    }
    if (url === "back") {
      url = (document.referrer) || alt;
    }
    return this.redirectURL = url;
  };

  return Request;

})();

module.exports = Request;
