/** Rill v0.0.484 https://www.npmjs.com/package/rill License: MIT*/
var byteLength, goTo, isType, statuses;

isType = require("is-type");

byteLength = require("./byteLength");

{
  goTo = require("../hijackBrowser/index").goTo;
}

statuses = {
  empty: {
    204: true,
    205: true,
    304: true
  },
  redirect: {
    300: true,
    301: true,
    302: true,
    303: true,
    305: true,
    307: true,
    308: true
  }
};


/*
 * A default middleware that handles sending the response for the request.
#
 * @param {Object} req
 * @param {Object} res
 * @param {Function} next
 */

module.exports = regeneratorRuntime.mark(function callee$0$0(req, res, next) {
  var body, headers, method, originalRes, redirectURL, status;

  return regeneratorRuntime.wrap(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
    case 0:
      context$1$0.next = 2;
      return next;
    case 2:
      method = req.method, redirectURL = req.redirectURL;
      originalRes = res.originalRes, headers = res.headers, status = res.status, body = res.body;

      if (!originalRes.headersSent) {
        context$1$0.next = 6;
        break;
      }

      return context$1$0.abrupt("return");
    case 6:
      if (!(redirectURL != null)) {
        context$1$0.next = 10;
        break;
      }

      if (!(redirectURL != null)) {
        context$1$0.next = 10;
        break;
      }

      goTo(redirectURL, {
        replaceState: true,
        headers: headers,
        method: method
      });
      return context$1$0.abrupt("return");
    case 10:
      if (Number(status) === 404 && (body != null)) {
        status = 200;
      }

      if (!(statuses.empty[status] || body == null)) {
        context$1$0.next = 16;
        break;
      }

      if (headers["content-type"] == null) {
        headers["content-type"] = void 0;
      }
      body = void 0;
      context$1$0.next = 29;
      break;
    case 16:
      if (!isType.String(body)) {
        context$1$0.next = 20;
        break;
      }

      if (headers["content-type"] == null) {
        headers["content-type"] = "text/" + (/^\s*</.test(body) ? "html" : "plain");
      }
      context$1$0.next = 29;
      break;
    case 20:
      if (!isType.Object(body)) {
        context$1$0.next = 25;
        break;
      }

      if (headers["content-type"] == null) {
        headers["content-type"] = "application/json";
      }
      body = JSON.stringify(body);
      context$1$0.next = 29;
      break;
    case 25:
      if (headers["content-type"] == null) {
        headers["content-type"] = "application/octet-stream";
      }
      if (body.length) {
        if (headers["content-length"] == null) {
          headers["content-length"] = body.length;
        }
      }

      if (!isType.Stream(body)) {
        context$1$0.next = 29;
        break;
      }

      return context$1$0.abrupt("return", body.pipe(originalRes));
    case 29:
      if (headers["content-length"] == null) {
        headers["content-length"] = byteLength(body);
      }
    case 30:
    case "end":
      return context$1$0.stop();
    }
  }, callee$0$0, this);
});
