serlialize = require("form-serialize")
parseURL   = require("parse-url")

module.exports =
	###
	# Handle an event that changed the url (popstate or page load)
	#
	# @param {Object} event
	###
	handleChange: (event)->
		goTo(window.location.href,
			method: "GET",
			replaceState: true
		)

	###
	# Handle intercepting form and link clicks to update the url.
	#
	# @param {Object} event
	###
	handleClick: (event)->
		#Ignore canceled events, modified clicks, and right clicks.
		return if event.defaultPrevented or
				  event.metaKey  or
				  event.ctrlKey  or
				  event.shiftKey or
				  event.button   isnt 0

		#Get the <a> element.
		el = event.target
		el = el.parentNode while el? and
								 el.nodeName isnt 'A' and
								 el.nodeName isnt "FORM"

		#Ignore clicks from non-a elements.
		return unless el?

		#Ignore the click if the element has a target.
		return if el.target and el.target isnt "_self"

		#Ignore the click if it's a download link. (We use this method of
		#detecting the presence of the attribute for old IE versions.)
		return if Boolean(el.attributes.download)

		#Use a regular expression to parse URLs instead of relying on the browser
		#to do it for us (because IE).
		url = el.href or el.action
		{ protocol, host } = parseURL(url, defaults: window.location)

		#Ignore links that don't share a protocol and host with ours.
		return if protocol isnt window.location.protocol or
				  host isnt window.location.host

		#Ignore 'rel="external"' links.
		return if el.rel and /(?:^|\s+)external(?:\s+|$)/.test(el.rel)

		goTo(url,
			method: el.method
			body: serlialize(el) if el.nodeName is "FORM"
		)

		event.preventDefault()

{ goTo } = require("./index")
