event         = require("component-event")
createRequest = ->

hijack = module.exports =
	###
	# Listen to all url change events on a dom element and trigger the server callback.
	#
	# @param {DOMNode} element
	# @api private
	###
	listen: (element = window)->
		event.bind(element, "DOMContentLoaded", handleChange)
		event.bind(element, "popstate", handleChange)
		event.bind(element, "submit", handleClick)
		event.bind(element, "click", handleClick)
		return hijack

	###
	# Add a handler to listen to url changes.
	#
	# @param {Function} handler
	# @api private
	###
	createServer: (handler)->
		createRequest = handler
		return hijack

	###
	# Trigger the registered handler to navigate to a given url.
	#
	# @param {String} url
	# @param {Object} options
	# @api private
	###
	goTo: (url, { method, headers, title, replaceState } = {})->
		title ?= ""
		req    =
			url: url
			method: method ? "GET"
			headers: headers ? {}

		window.history[if Boolean(replaceState) then "replaceState" else "pushState"](req, title, url)
		createRequest(req)
		return

{ handleClick, handleChange } = require("./handlers")
